;  ADVERT.LSP    Add a Vertex   (c)1995, Steve Houghton
;revised 3/23/95 to ensure new vertex is at crosshairs
;thanks to Patrick Wheatley

;Inserts a vertex in a polyline.  If a line is selected, it offers to convert
;it to a polyline and then insert the vertex.
;Will report: At least one break point must be on polyline. if the end of 
;a polyline is chosen
;***************************************************************************

(defun C:ADV ( / OB OC OO OH POLYLINE POLYNAME PICKPOINT POLYDXF ENTTYPE
   LASTENT NEWVERT OLDERR ANSWER INSERTVERT)

   (princ "\nADD VERTEX")

   ;*set all env variables,  
   ;*osmode to avoid conflicts with the osnap
   ;*blipmode to make her pretty
   (setq OO (getvar "OSMODE")
      OB (getvar "BLIPMODE")
      OH (getvar "HIGHLIGHT")
      OC (getvar "CMDECHO")
      OLDERR *error*
     *error* MC_ERR
   ) 


   ;*vertext insert routine      
   (defun insertvert()
      ;*ensure that last entity is not a compound entity
      ;*by creating a simple temporary entity as the last entity in the
      ;*database this way we can be sure that the next two entities
      ;*will be the two new polylines created by breaking the current
      ;*polyline
      (entmake (list '(0 . "POINT") (cons 10 (getvar "VSMIN"))))
      (setq LASTENT (entlast))
      ;*breaks polyline at pickpoint
      (command "_break" POLYNAME PICKPOINT PICKPOINT)

      ;*(entnext lastent) will be the next polyline created after lastent
      ;*(entlast) will be the other polyline created
      ;*so now join the two and we have a polyline with the new vertex
      ;*inserted
      (command "_PEDIT" (entnext LASTENT) "_join" (entlast) "" exit)
      ;*get rid of temporary point
      (entdel LASTENT)
      (princ "\nMove new vertex: ")
      (setq NEWVERT (osnap pickpoint "int,vic"))
      (COMMAND "_STRETCH" "_C" NEWVERT NEWVERT "" PICKPOINT pause)
   );insertvert        

   (setvar "OSMODE" 0)
   (setvar "BLIPMODE" 0)
   (setvar "HIGHLIGHT" 0)
   (setvar "CMDECHO" 0)

   (while (setq POLYLINE (entsel))
      (setq POLYNAME (car POLYLINE)
         PICKPOINT (osnap (cadr POLYLINE) "_nea")
         POLYDXF (entget POLYNAME)
         ENTTYPE (cdr (assoc 0 POLYDXF))
      )

      (if (= enttype "POLYLINE")
         (insertvert)
         (if (= enttype "LINE")
            (progn 
               (initget "Y y N n")
               (setq ANSWER (getkword "\nDo you wish to turn this line to a polyline <Y>? "))
               (if (or (null ANSWER)
                     (= ANSWER "Y") 
                  (= ANSWER "y"))
                  (progn 
                     ;*turn current line into a polyline
                     (command "_pedit" POLYNAME "_y" "")
                     (insertvert)
                  );progn
               );if
            );progn

            (princ "\nMust Select a polyline or line.")
         );if
      );if
   );while

   (setvar "OSMODE" oo)
   (setvar "BLIPMODE" ob)
   (setvar "HIGHLIGHT" oh)
   (setvar "CMDECHO" oc)
   (setq *error* OLDERR)
   (princ)
);end advert.lsp
